diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/tcp-yeah-test.cc ns-3.42/src/internet/test/tcp-yeah-test.cc
--- ns-3.41/src/internet/test/tcp-yeah-test.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/internet/test/tcp-yeah-test.cc	2024-05-29 15:29:46.972073300 -0700
@@ -364,7 +364,7 @@
 {
   public:
     TcpYeahTestSuite()
-        : TestSuite("tcp-yeah-test", UNIT)
+        : TestSuite("tcp-yeah-test", Type::UNIT)
     {
         AddTestCase(new TcpYeahIncrementTest(20 * 1446,
                                              25 * 1446,
@@ -374,7 +374,7 @@
                                              1,
                                              MilliSeconds(105),
                                              "YeAH test on cWnd when in slow start"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new TcpYeahIncrementTest(30 * 1446,
                                              25 * 1446,
                                              1446,
@@ -383,7 +383,7 @@
                                              30,
                                              MilliSeconds(105),
                                              "YeAH test on cWnd when in Fast mode"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new TcpYeahIncrementTest(
                         40 * 356,
                         30 * 356,
@@ -393,7 +393,7 @@
                         1,
                         MilliSeconds(120),
                         "YeAH test on cWnd when in slow mode without precautionary decongestion"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new TcpYeahIncrementTest(
                         100 * 356,
                         70 * 356,
@@ -403,7 +403,7 @@
                         1,
                         MilliSeconds(600),
                         "YeAH test on cWnd when in slow mode with precautionary decongestion"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new TcpYeahDecrementTest(
                         40 * 1446,
                         30 * 1446,
@@ -413,7 +413,7 @@
                         MilliSeconds(120),
                         UintegerValue(0),
                         "YeAH test on ssThresh upon loss while competing with Reno flows"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new TcpYeahDecrementTest(
                         57 * 1446,
                         42 * 1446,
@@ -423,7 +423,7 @@
                         MilliSeconds(200),
                         UintegerValue(2),
                         "YeAH test on ssThresh upon loss while not competing with Reno flows"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/tcp-zero-window-test.cc ns-3.42/src/internet/test/tcp-zero-window-test.cc
--- ns-3.41/src/internet/test/tcp-zero-window-test.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/internet/test/tcp-zero-window-test.cc	2024-05-29 15:29:46.972073300 -0700
@@ -236,7 +236,7 @@
         if (h.GetFlags() & TcpHeader::SYN)
         {
             EventId persistentEvent = GetPersistentEvent(SENDER);
-            NS_TEST_ASSERT_MSG_EQ(persistentEvent.IsRunning(),
+            NS_TEST_ASSERT_MSG_EQ(persistentEvent.IsPending(),
                                   true,
                                   "Persistent event not started");
         }
@@ -255,9 +255,9 @@
 {
   public:
     TcpZeroWindowTestSuite()
-        : TestSuite("tcp-zero-window-test", UNIT)
+        : TestSuite("tcp-zero-window-test", Type::UNIT)
     {
-        AddTestCase(new TcpZeroWindowTest("zero window test"), TestCase::QUICK);
+        AddTestCase(new TcpZeroWindowTest("zero window test"), TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/udp-test.cc ns-3.42/src/internet/test/udp-test.cc
--- ns-3.41/src/internet/test/udp-test.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/internet/test/udp-test.cc	2024-05-29 15:29:46.972073300 -0700
@@ -490,10 +490,8 @@
                                               MakeCallback(&UdpSocketImplTest::SentPkt, this));
 
     // The socket is not connected.
-    txSocket->SetIpTos(0x28); // AF11
     txSocket->SetPriority(6); // Interactive
     // Send a packet to a specified destination:
-    // - for not connected sockets, the tos specified in the destination address (0) is used
     // - since the tos is zero, the priority set for the socket is used
     SendDataTo(txSocket, "10.0.0.1");
     NS_TEST_EXPECT_MSG_EQ(m_receivedPacket->GetSize(), 123, "trivial");
@@ -504,7 +502,7 @@
     m_receivedPacket->RemoveAllByteTags();
 
     InetSocketAddress dest("10.0.0.1", 1234);
-    dest.SetTos(0xb8); // EF
+    txSocket->SetIpTos(0xb8); // EF
     // the connect operation sets the tos (and priority) for the socket
     NS_TEST_EXPECT_MSG_EQ(txSocket->Connect(dest), 0, "the connect operation failed");
 
@@ -771,12 +769,12 @@
 {
   public:
     UdpTestSuite()
-        : TestSuite("udp", UNIT)
+        : TestSuite("udp", Type::UNIT)
     {
-        AddTestCase(new UdpSocketImplTest, TestCase::QUICK);
-        AddTestCase(new UdpSocketLoopbackTest, TestCase::QUICK);
-        AddTestCase(new Udp6SocketImplTest, TestCase::QUICK);
-        AddTestCase(new Udp6SocketLoopbackTest, TestCase::QUICK);
+        AddTestCase(new UdpSocketImplTest, TestCase::Duration::QUICK);
+        AddTestCase(new UdpSocketLoopbackTest, TestCase::Duration::QUICK);
+        AddTestCase(new Udp6SocketImplTest, TestCase::Duration::QUICK);
+        AddTestCase(new Udp6SocketLoopbackTest, TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/examples/traceroute-example.cc ns-3.42/src/internet-apps/examples/traceroute-example.cc
--- ns-3.41/src/internet-apps/examples/traceroute-example.cc	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/examples/traceroute-example.cc	2024-05-29 15:29:46.952073000 -0700
@@ -18,8 +18,6 @@
  *
  *
  * TraceRoute application example using AODV routing protocol.
- *
- *
  */
 
 #include "ns3/aodv-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/helper/ping-helper.cc ns-3.42/src/internet-apps/helper/ping-helper.cc
--- ns-3.41/src/internet-apps/helper/ping-helper.cc	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/helper/ping-helper.cc	2024-05-29 15:29:46.952073000 -0700
@@ -24,62 +24,19 @@
 
 #include "ping-helper.h"
 
-#include "ns3/names.h"
-#include "ns3/ping.h"
-
 namespace ns3
 {
 
 PingHelper::PingHelper()
+    : ApplicationHelper("ns3::Ping")
 {
-    m_factory.SetTypeId("ns3::Ping");
 }
 
-PingHelper::PingHelper(Address remote, Address local)
+PingHelper::PingHelper(const Address& remote, const Address& local)
+    : ApplicationHelper("ns3::Ping")
 {
-    m_factory.SetTypeId("ns3::Ping");
     m_factory.Set("Destination", AddressValue(remote));
     m_factory.Set("InterfaceAddress", AddressValue(local));
 }
 
-void
-PingHelper::SetAttribute(std::string name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-ApplicationContainer
-PingHelper::Install(Ptr<Node> node) const
-{
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-PingHelper::Install(std::string nodeName) const
-{
-    Ptr<Node> node = Names::Find<Node>(nodeName);
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-PingHelper::Install(NodeContainer c) const
-{
-    ApplicationContainer apps;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        apps.Add(InstallPriv(*i));
-    }
-
-    return apps;
-}
-
-Ptr<Application>
-PingHelper::InstallPriv(Ptr<Node> node) const
-{
-    Ptr<Ping> app = m_factory.Create<Ping>();
-    node->AddApplication(app);
-
-    return app;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/helper/ping-helper.h ns-3.42/src/internet-apps/helper/ping-helper.h
--- ns-3.41/src/internet-apps/helper/ping-helper.h	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/helper/ping-helper.h	2024-05-29 15:29:46.952073000 -0700
@@ -25,14 +25,8 @@
 #ifndef PING_HELPER_H
 #define PING_HELPER_H
 
-#include "ns3/application-container.h"
-#include "ns3/ipv4-address.h"
-#include "ns3/ipv6-address.h"
-#include "ns3/node-container.h"
-#include "ns3/object-factory.h"
 #include "ns3/ping.h"
-
-#include <stdint.h>
+#include <ns3/application-helper.h>
 
 namespace ns3
 {
@@ -44,7 +38,7 @@
  * This class creates one or multiple instances of ns3::Ping and associates
  * it/them to one/multiple node(s).
  */
-class PingHelper
+class PingHelper : public ApplicationHelper
 {
   public:
     /**
@@ -60,55 +54,7 @@
      * \param remote The address which should be pinged
      * \param local The source address
      */
-    PingHelper(Address remote, Address local = Address());
-
-    /**
-     * Install a Ping application on each Node in the provided NodeContainer.
-     *
-     * \param nodes The NodeContainer containing all of the nodes to get a Ping
-     *              application.
-     *
-     * \returns A list of Ping applications, one for each input node
-     */
-    ApplicationContainer Install(NodeContainer nodes) const;
-
-    /**
-     * Install a Ping application on the provided Node.  The Node is specified
-     * directly by a Ptr<Node>
-     *
-     * \param node The node to install the Ping application on.
-     *
-     * \returns An ApplicationContainer holding the Ping application created.
-     */
-    ApplicationContainer Install(Ptr<Node> node) const;
-
-    /**
-     * Install a Ping application on the provided Node.  The Node is specified
-     * by a string that must have previously been associated with a Node using the
-     * Object Name Service.
-     *
-     * \param nodeName The node to install the Ping application on.
-     *
-     * \returns An ApplicationContainer holding the Ping application created.
-     */
-    ApplicationContainer Install(std::string nodeName) const;
-
-    /**
-     * \brief Configure ping applications attribute
-     * \param name   attribute's name
-     * \param value  attribute's value
-     */
-    void SetAttribute(std::string name, const AttributeValue& value);
-
-  private:
-    /**
-     * \brief Do the actual application installation in the node
-     * \param node the node
-     * \returns a Smart pointer to the installed application
-     */
-    Ptr<Application> InstallPriv(Ptr<Node> node) const;
-    /// Object factory
-    ObjectFactory m_factory;
+    PingHelper(const Address& remote, const Address& local = Address());
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/helper/radvd-helper.cc ns-3.42/src/internet-apps/helper/radvd-helper.cc
--- ns-3.41/src/internet-apps/helper/radvd-helper.cc	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/helper/radvd-helper.cc	2024-05-29 15:29:46.952073000 -0700
@@ -31,12 +31,14 @@
 NS_LOG_COMPONENT_DEFINE("RadvdHelper");
 
 RadvdHelper::RadvdHelper()
+    : ApplicationHelper(Radvd::GetTypeId())
 {
-    m_factory.SetTypeId(Radvd::GetTypeId());
 }
 
 void
-RadvdHelper::AddAnnouncedPrefix(uint32_t interface, Ipv6Address prefix, uint32_t prefixLength)
+RadvdHelper::AddAnnouncedPrefix(uint32_t interface,
+                                const Ipv6Address& prefix,
+                                uint32_t prefixLength)
 {
     NS_LOG_FUNCTION(this << int(interface) << prefix << int(prefixLength));
     if (prefixLength != 64)
@@ -109,27 +111,19 @@
     m_radvdInterfaces.clear();
 }
 
-void
-RadvdHelper::SetAttribute(std::string name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-ApplicationContainer
-RadvdHelper::Install(Ptr<Node> node)
+Ptr<Application>
+RadvdHelper::DoInstall(Ptr<Node> node)
 {
-    ApplicationContainer apps;
-    Ptr<Radvd> radvd = m_factory.Create<Radvd>();
-    for (auto iter = m_radvdInterfaces.begin(); iter != m_radvdInterfaces.end(); iter++)
+    auto radvd = m_factory.Create<Radvd>();
+    for (auto [index, interface] : m_radvdInterfaces)
     {
-        if (!iter->second->GetPrefixes().empty())
+        if (!interface->GetPrefixes().empty())
         {
-            radvd->AddConfiguration(iter->second);
+            radvd->AddConfiguration(interface);
         }
     }
     node->AddApplication(radvd);
-    apps.Add(radvd);
-    return apps;
+    return radvd;
 }
 
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/helper/radvd-helper.h ns-3.42/src/internet-apps/helper/radvd-helper.h
--- ns-3.41/src/internet-apps/helper/radvd-helper.h	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/helper/radvd-helper.h	2024-05-29 15:29:46.952073000 -0700
@@ -20,13 +20,9 @@
 #ifndef RADVD_HELPER_H
 #define RADVD_HELPER_H
 
-#include "ns3/application-container.h"
-#include "ns3/ipv6-address.h"
-#include "ns3/node-container.h"
-#include "ns3/object-factory.h"
 #include "ns3/radvd-interface.h"
+#include <ns3/application-helper.h>
 
-#include <list>
 #include <map>
 #include <stdint.h>
 
@@ -37,7 +33,7 @@
  * \ingroup radvd
  * \brief Radvd application helper.
  */
-class RadvdHelper
+class RadvdHelper : public ApplicationHelper
 {
   public:
     /**
@@ -51,7 +47,7 @@
      * \param prefix announced IPv6 prefix
      * \param prefixLength announced IPv6 prefix length
      */
-    void AddAnnouncedPrefix(uint32_t interface, Ipv6Address prefix, uint32_t prefixLength);
+    void AddAnnouncedPrefix(uint32_t interface, const Ipv6Address& prefix, uint32_t prefixLength);
 
     /**
      * \brief Enable the router as default router for the interface.
@@ -80,25 +76,8 @@
      */
     void ClearPrefixes();
 
-    /**
-     * \brief Set some attributes.
-     * \param name attribute name
-     * \param value attribute value
-     */
-    void SetAttribute(std::string name, const AttributeValue& value);
-
-    /**
-     * \brief Install the application in a Node.
-     * \param node the Node
-     * \return application container
-     */
-    ApplicationContainer Install(Ptr<Node> node);
-
   private:
-    /**
-     * \brief An object factory.
-     */
-    ObjectFactory m_factory;
+    Ptr<Application> DoInstall(Ptr<Node> node) override;
 
     /// Container: interface index, RadvdInterface
     typedef std::map<uint32_t, Ptr<RadvdInterface>> RadvdInterfaceMap;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/helper/v4traceroute-helper.cc ns-3.42/src/internet-apps/helper/v4traceroute-helper.cc
--- ns-3.41/src/internet-apps/helper/v4traceroute-helper.cc	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/helper/v4traceroute-helper.cc	2024-05-29 15:29:46.952073000 -0700
@@ -21,67 +21,24 @@
 
 #include "v4traceroute-helper.h"
 
-#include "ns3/names.h"
+#include "ns3/output-stream-wrapper.h"
 #include "ns3/v4traceroute.h"
 
 namespace ns3
 {
 
-V4TraceRouteHelper::V4TraceRouteHelper(Ipv4Address remote)
+V4TraceRouteHelper::V4TraceRouteHelper(const Ipv4Address& remote)
+    : ApplicationHelper("ns3::V4TraceRoute")
 {
-    m_factory.SetTypeId("ns3::V4TraceRoute");
     m_factory.Set("Remote", Ipv4AddressValue(remote));
 }
 
 void
-V4TraceRouteHelper::SetAttribute(std::string name, const AttributeValue& value)
-{
-    m_factory.Set(name, value);
-}
-
-ApplicationContainer
-V4TraceRouteHelper::Install(Ptr<Node> node) const
-{
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-V4TraceRouteHelper::Install(std::string nodeName) const
-{
-    Ptr<Node> node = Names::Find<Node>(nodeName);
-    return ApplicationContainer(InstallPriv(node));
-}
-
-ApplicationContainer
-V4TraceRouteHelper::Install(NodeContainer c) const
-{
-    ApplicationContainer apps;
-    for (auto i = c.Begin(); i != c.End(); ++i)
-    {
-        apps.Add(InstallPriv(*i));
-    }
-
-    return apps;
-}
-
-Ptr<Application>
-V4TraceRouteHelper::InstallPriv(Ptr<Node> node) const
-{
-    Ptr<V4TraceRoute> app = m_factory.Create<V4TraceRoute>();
-    node->AddApplication(app);
-
-    return app;
-}
-
-void
 V4TraceRouteHelper::PrintTraceRouteAt(Ptr<Node> node, Ptr<OutputStreamWrapper> stream)
 {
-    Ptr<V4TraceRoute> trace;
-
     for (uint32_t i = 0; i < node->GetNApplications(); ++i)
     {
-        trace = node->GetApplication(i)->GetObject<V4TraceRoute>();
-        if (trace)
+        if (auto trace = node->GetApplication(i)->GetObject<V4TraceRoute>())
         {
             *stream->GetStream() << "Tracing Route from Node " << node->GetId() << "\n";
             trace->Print(stream);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/helper/v4traceroute-helper.h ns-3.42/src/internet-apps/helper/v4traceroute-helper.h
--- ns-3.41/src/internet-apps/helper/v4traceroute-helper.h	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/helper/v4traceroute-helper.h	2024-05-29 15:29:46.952073000 -0700
@@ -22,14 +22,13 @@
 #ifndef V4TRACEROUTE_HELPER_H
 #define V4TRACEROUTE_HELPER_H
 
-#include "ns3/application-container.h"
-#include "ns3/node-container.h"
-#include "ns3/object-factory.h"
-#include "ns3/output-stream-wrapper.h"
+#include <ns3/application-helper.h>
 
 namespace ns3
 {
 
+class OutputStreamWrapper;
+
 /**
  * \ingroup v4traceroute
  * \brief Create a IPv4 traceroute application and associate it to a node
@@ -37,7 +36,7 @@
  * This class creates one or multiple instances of ns3::V4TraceRoute and associates
  * it/them to one/multiple node(s).
  */
-class V4TraceRouteHelper
+class V4TraceRouteHelper : public ApplicationHelper
 {
   public:
     /**
@@ -46,61 +45,14 @@
      *
      * \param remote The address which should be traced
      */
-    V4TraceRouteHelper(Ipv4Address remote);
-
-    /**
-     * Install a TraceRoute application on each Node in the provided NodeContainer.
-     *
-     * \param nodes The NodeContainer containing all of the nodes to get a V4TraceRoute
-     *              application.
-     *
-     * \returns A list of TraceRoute applications, one for each input node
-     */
-    ApplicationContainer Install(NodeContainer nodes) const;
-
-    /**
-     * Install a TraceRoute application on the provided Node.  The Node is specified
-     * directly by a Ptr<Node>
-     *
-     * \param node The node to install the V4TraceRouteApplication on.
-     *
-     * \returns An ApplicationContainer holding the TraceRoute application created.
-     */
-    ApplicationContainer Install(Ptr<Node> node) const;
+    V4TraceRouteHelper(const Ipv4Address& remote);
 
     /**
-     * Install a TraceRoute application on the provided Node.  The Node is specified
-     * by a string that must have previously been associated with a Node using the
-     * Object Name Service.
-     *
-     * \param nodeName The node to install the V4TraceRouteApplication on.
-     *
-     * \returns An ApplicationContainer holding the TraceRoute application created.
-     */
-    ApplicationContainer Install(std::string nodeName) const;
-
-    /**
-     * \brief Configure traceRoute applications attribute
-     * \param name   attribute's name
-     * \param value  attribute's value
-     */
-    void SetAttribute(std::string name, const AttributeValue& value);
-    /**
      * \brief Print the resulting trace routes from given node.
      * \param node The origin node where the traceroute is initiated.
      * \param stream The outputstream used to print the resulting traced routes.
      */
     static void PrintTraceRouteAt(Ptr<Node> node, Ptr<OutputStreamWrapper> stream);
-
-  private:
-    /**
-     * \brief Do the actual application installation in the node
-     * \param node the node
-     * \returns a Smart pointer to the installed application
-     */
-    Ptr<Application> InstallPriv(Ptr<Node> node) const;
-    /// Object factory
-    ObjectFactory m_factory;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/model/dhcp-client.h ns-3.42/src/internet-apps/model/dhcp-client.h
--- ns-3.41/src/internet-apps/model/dhcp-client.h	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/model/dhcp-client.h	2024-05-29 15:29:46.952073000 -0700
@@ -80,20 +80,15 @@
      */
     Ipv4Address GetDhcpServer();
 
-    /**
-     * Assign a fixed random variable stream number to the random variables
-     * used by this model. Return the number of streams (possibly zero) that
-     * have been assigned.
-     *
-     * \param stream First stream index to use
-     * \return the number of stream indices assigned by this model
-     */
-    int64_t AssignStreams(int64_t stream);
+    int64_t AssignStreams(int64_t stream) override;
 
   protected:
     void DoDispose() override;
 
   private:
+    void StartApplication() override;
+    void StopApplication() override;
+
     /// client states
     enum States
     {
@@ -104,16 +99,6 @@
 
     static const int DHCP_PEER_PORT = 67; //!< DHCP server port
 
-    /*
-     * \brief Starts the DHCP client application
-     */
-    void StartApplication() override;
-
-    /*
-     * \brief Stops the DHCP client application
-     */
-    void StopApplication() override;
-
     /**
      * \brief Handles changes in LinkState
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/model/dhcp-server.h ns-3.42/src/internet-apps/model/dhcp-server.h
--- ns-3.41/src/internet-apps/model/dhcp-server.h	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/model/dhcp-server.h	2024-05-29 15:29:46.952073000 -0700
@@ -68,6 +68,9 @@
     void DoDispose() override;
 
   private:
+    void StartApplication() override;
+    void StopApplication() override;
+
     static const int PORT = 67; //!< Port number of DHCP server
 
     /**
@@ -97,16 +100,6 @@
      */
     void TimerHandler();
 
-    /**
-     * \brief Starts the DHCP Server application
-     */
-    void StartApplication() override;
-
-    /**
-     * \brief Stops the DHCP client application
-     */
-    void StopApplication() override;
-
     Ptr<Socket> m_socket;      //!< The socket bound to port 67
     Ipv4Address m_poolAddress; //!< The network address available to the server
     Ipv4Address m_minAddress;  //!< The first address in the address pool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/model/ping.cc ns-3.42/src/internet-apps/model/ping.cc
--- ns-3.41/src/internet-apps/model/ping.cc	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/model/ping.cc	2024-05-29 15:29:46.952073000 -0700
@@ -462,7 +462,6 @@
         }
         p->AddHeader(header);
         auto dest = InetSocketAddress(Ipv4Address::ConvertFrom(m_destination), 0);
-        dest.SetTos(m_tos);
         returnValue = m_socket->SendTo(p, 0, dest);
     }
     else
@@ -563,6 +562,7 @@
         NS_ASSERT_MSG(m_socket, "Ping::StartApplication: can not create socket.");
         m_socket->SetAttribute("Protocol", UintegerValue(1)); // icmp
         m_socket->SetRecvCallback(MakeCallback(&Ping::Receive, this));
+        m_socket->SetIpTos(m_tos);
         m_useIpv6 = false;
 
         Ipv4Address dst = Ipv4Address::ConvertFrom(m_destination);
@@ -626,11 +626,11 @@
 Ping::StopApplication()
 {
     NS_LOG_FUNCTION(this);
-    if (m_stopEvent.IsRunning())
+    if (m_stopEvent.IsPending())
     {
         m_stopEvent.Cancel();
     }
-    if (m_next.IsRunning())
+    if (m_next.IsPending())
     {
         m_next.Cancel();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/model/ping.h ns-3.42/src/internet-apps/model/ping.h
--- ns-3.41/src/internet-apps/model/ping.h	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/model/ping.h	2024-05-29 15:29:46.952073000 -0700
@@ -147,7 +147,13 @@
      */
     typedef void (*ReportTrace)(const PingReport& report);
 
+  protected:
+    void DoDispose() override;
+
   private:
+    void StartApplication() override;
+    void StopApplication() override;
+
     /**
      * \brief Writes data to buffer in little-endian format.
      *
@@ -166,11 +172,6 @@
      */
     uint64_t Read64(const uint8_t* buffer);
 
-    // inherited from Application base class.
-    void StartApplication() override;
-    void StopApplication() override;
-    void DoDispose() override;
-
     /**
      * \brief Return the application signatiure.
      * \returns the application signature.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/model/radvd.cc ns-3.42/src/internet-apps/model/radvd.cc
--- ns-3.41/src/internet-apps/model/radvd.cc	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/model/radvd.cc	2024-05-29 15:29:46.952073000 -0700
@@ -369,7 +369,7 @@
                         if (m_solicitedEventIds.find((*it)->GetInterface()) !=
                             m_solicitedEventIds.end())
                         {
-                            if (m_solicitedEventIds[(*it)->GetInterface()].IsRunning())
+                            if (m_solicitedEventIds[(*it)->GetInterface()].IsPending())
                             {
                                 scheduleSingle = false;
                             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/model/radvd.h ns-3.42/src/internet-apps/model/radvd.h
--- ns-3.41/src/internet-apps/model/radvd.h	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/model/radvd.h	2024-05-29 15:29:46.952073000 -0700
@@ -85,23 +85,15 @@
      */
     void AddConfiguration(Ptr<RadvdInterface> routerInterface);
 
-    /**
-     * Assign a fixed random variable stream number to the random variables
-     * used by this model.  Return the number of streams (possibly zero) that
-     * have been assigned.
-     *
-     * \param stream first stream index to use
-     * \return the number of stream indices assigned by this model
-     */
-    int64_t AssignStreams(int64_t stream);
+    int64_t AssignStreams(int64_t stream) override;
 
   protected:
-    /**
-     * \brief Dispose the instance.
-     */
     void DoDispose() override;
 
   private:
+    void StartApplication() override;
+    void StopApplication() override;
+
     /// Container: Ptr to RadvdInterface
     typedef std::list<Ptr<RadvdInterface>> RadvdInterfaceList;
     /// Container Iterator: Ptr to RadvdInterface
@@ -124,16 +116,6 @@
     typedef std::map<uint32_t, Ptr<Socket>>::const_iterator SocketMapCI;
 
     /**
-     * \brief Start the application.
-     */
-    void StartApplication() override;
-
-    /**
-     * \brief Stop the application.
-     */
-    void StopApplication() override;
-
-    /**
      * \brief Send a packet.
      * \param config interface configuration
      * \param dst destination address (default ff02::1)
